package jalview.ext.android;

import static org.testng.Assert.assertEquals;

import org.testng.annotations.Test;

/*
 * Tests for SparseIntArray. Unlike SparseShortArray, SparseIntArray does not throw
 * any exception for overflow.
 */
public class SparseIntArrayTest
{
  @Test(groups = "Functional")
  public void testPut()
  {
    SparseIntArray counter = new SparseIntArray();

    /*
     * either key or value may be in the range of int
     */
    counter.put(Integer.MAX_VALUE, Integer.MIN_VALUE);
    counter.put(Integer.MIN_VALUE, Integer.MAX_VALUE);
    assertEquals(counter.get(Integer.MAX_VALUE), Integer.MIN_VALUE);
    assertEquals(counter.get(Integer.MIN_VALUE), Integer.MAX_VALUE);
  }

  @Test(groups = "Functional")
  public void testAdd()
  {
    SparseIntArray counter = new SparseIntArray();
  
    assertEquals(counter.add('P', 2), 2);
    assertEquals(counter.add('P', 3), 5);
    counter.put('Q', 7);
    assertEquals(counter.add('Q', 4), 11);

    counter.put('x', Integer.MAX_VALUE);
    counter.add('x', 1);
  
    counter.put('y', Integer.MIN_VALUE);
    counter.add('y', -1);
  }
}
